#include <stdio.h>
#include <stdlib.h>
#include <string.h>

/* FUNZIONE DA REALIZZARE
   ======================

   Realizzare la funzione f(s) in base alla specifica seguente. La
   funzione accetta come parametro una stringa di lunghezza n>=1, i
   cui caratteri possono essere '0' oppure '1'. La funzione
   restituisce una NUOVA stringa r avente lunghezza (n+1). I primi n
   caratteri di r devono essere uguali a quelli di s; l'ultimo
   carattere a destra di r vale '0' oppure '1' in modo che in r
   ci sia un numero _PARI_ di caratteri '1'.

   Ad esempio, se s = "1010", allora r = "10100"; se s = "1101",
   allora r = "11011". Si noti come r si ottenga appendendo
   ad s il carattere '0' oppure '1', in modo che cio' che si ottiene
   contenga un numero pari di '1'.

   Il numero di test forniti in questa funzione e' insufficiente per
   una verifica approfondita del risultato. Si aggiungano almeno TRE
   ulteriori casi di test al main. Si ricordi comunque che una
   funzione che supera i test non e' necessariamente corretta.

   E' sempre possibile definire ulteriori funzioni di supporto, se
   necessario.
*/
char *f( char *s )
{
    return NULL;
}

void test(char *s, char *atteso)
{
    char *ottenuto = f(s);
    if ((ottenuto != NULL) && (strcmp(atteso, ottenuto) == 0)) {
        printf("Test OK\n");
    } else {
        printf("Test FALLITO: s=%s, risultato atteso=%s, risultato ottenuto=%s\n", s, atteso, ottenuto);
    }
    free(ottenuto);
}

int main( void )
{
    test("1010", "10100");
    test("1101", "11011");
    return 0;
}
